# Record Class CATypeFieldDeclaration

java.lang.Object
java.lang.Record
com.io7m.cardant.model.type_package.CATypeFieldDeclaration

Record Components:
  `name` - The field name
  `description` - The field description
  `type` - The field type
  `isRequired` - `true` if the field is required

public record CATypeFieldDeclaration(CANameUnqualified name, String description, CATypeScalarIdentifier type, boolean isRequired) extends Record
A field declared within a record type.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CATypeFieldDeclaration(CANameUnqualified name, String description, CATypeScalarIdentifier type, boolean isRequired)`
  A field declared within a record type.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `description()`
  Returns the value of the `description` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `boolean`
  `isRequired()`
  Returns the value of the `isRequired` record component.
  `CANameUnqualified`
  `name()`
  Returns the value of the `name` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `CATypeScalarIdentifier`
  `type()`
  Returns the value of the `type` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CATypeFieldDeclaration

    public CATypeFieldDeclaration(CANameUnqualified name, String description, CATypeScalarIdentifier type, boolean isRequired)
    A field declared within a record type.
    Parameters:
      `name` - The field name
      `description` - The field description
      `type` - The field type
      `isRequired` - `true` if the field is required

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public CANameUnqualified name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component

  - ### description

    public String description()
    Returns the value of the `description` record component.
    Returns:
      the value of the `description` record component

  - ### type

    public CATypeScalarIdentifier type()
    Returns the value of the `type` record component.
    Returns:
      the value of the `type` record component

  - ### isRequired

    public boolean isRequired()
    Returns the value of the `isRequired` record component.
    Returns:
      the value of the `isRequired` record component